
#include 'MSI.ch'

 ////////////
 //
FUNCTION ArraySkip_(nSkip, nArrayIndex, nLenArray)
 //      Efetua o "salto" nos arrays,  semelhana de DbSkip(), e 
 //             usado em ::oBrowse:skipBlock({|nQtos| ArraySip_(nQtos, @nArrayIndex)} onde:
 //             <nSkip>        -> quantos itens a saltar
 //             <@narrayIndex> -> ndice do array
 //             <nLenArray>    -> quantos itens tem o array
 //
 //      Retorna quantos itens do array foram "saltados"
*************
LOCAL  nNewInd, nSkipped
if nSkip     == 0 .or.;
   nLenArray == 0
   nSkipped  := 0
else
   nNewInd            := (nArrayIndex + nSkip)
   if     nNewInd      < 1
          nSkipped    := (1 - nArrayIndex)
          nArrayIndex := 1
   elseif nNewInd      > nLenArray
          nSkipped    := (nLenArray - nArrayIndex)
          nArrayIndex := nLenArray
   else
          nArrayIndex :=  nNewInd
          nSkipped    := nSkip
   endif
endif
RETURN nSkipped

 ////////////
 //
FUNCTION ArrayGoTop_(nArrayIndex)
 //      Posiciona no primeiro item do array onde:
 //                @<nArrayIndex> -> ndice do array
 //      Retorna NIL
 /////
nArrayIndex := 1
RETURN NIL

 ///////////
 //
FUNCTION ArrayGoBottom_(nArrayIndex, nLenArray)
 //      Posiciona no ltimo elemento do array onde:
 //                @<nArrayIndex> -> ndice usado na indeao do array
 //                <nLenArray>    -> quantos itens o array tem
 //      Retorna NIL
 /////
nArrayIndex := nLenArray
RETURN NIL

 ////////////
FUNCTION ArrayGoto_(nNewItem, nArrayIndex, nLenArray)
 //      Posiciona no item do array onde:
 //                <nNewItem>    -> item que se deseja posicionar o array
 //               @<nArrayIndex> -> ndice usado na indexao do array
 //                <nLenArray>   -> quantos itens o array tem
 // RETORNA NIL
 /////
if nNewItem <= nLenArray .and.;
   nNewItem  > 0 
   nArrayIndex := nNewItem
endif
RETURN NIL

 ////////////
 //
FUNCTION CabBrowseGetGranularity_(nQty)
 //      Retorna a granularidade (quantidade de registros para serem usados para a 
 //              movimentao da XbpScrollBar() vertical) usada pelas member vars
 //              XbpBrowse():posBlock, XbpBrowse():goPosBlock e XbpBrowse():lastPosBlock
 //////
LOCAL  nGranular
                  //
                  //    O movimento da scroll bar  em percentual de 0 a 100
                  //      Quantidade de registros para movimentar 1 posio da scroll bar
if     nQty      >= 10000
       nGranular := 100
elseif nQty      >= 1000
       nGranular := 10
elseif nQty      >= 100
       nGranular := 2
else
       nGranular := 1
endif
RETURN nGranular

 ////////////
 //
CLASS CabDlgBrowse_ FROM XbpDialog
 //
 //   "Container" de XbpBrowse()
 //   Esta janela (CabBrowse_:oDlg) tem como objetivo ser a container de XbpBrowse()
 //        e todo o posicionamento de Self  feito atravs dela.
 //        Ela contm um objeto usado para fazer a descrio da linha de XbpBrowse()
 //        (::oDlgshowDetail(<bRowDetail>) que est estabilizada.
 //
 //   Veja a descrio dos parmetros em CabBowse_()
 //
 //   Ela  criada como XBP_DISP_SYSMODAL.
 //
 //   Retorna Self
 /////
EXPORTED:
   CLASS VAR  aPPDetails SHARED

   VAR        oOldApp
   VAR        oHadFocus
   VAR        bClose
   VAR        oPushBarr          // Barra de pushbuttons
   VAR        oBoxDetail         // Box que contm o texto descritivo da linha de XbpBrowse() que tem o foco
   VAR        oDetail            // Texto descritivoda linha de XbpBrowse() exibido em ::oBoxDetail
   VAR        nMaxWidth          // Maior extenso possvel para XbpBrowse()
   VAR        nDetailsHeight     // Altura da rea de exibir os detalhes + barra de pushbuttons
   VAR        oBrowse            // XbpBrowse()


   INLINE CLASS METHOD initClass()
          ::aPPDetails := cabBROW_PP_DETAILS
   RETURN ::XbpDialog:initClass()

   INLINE METHOD init(oParent, oOwner, aPos, aSize, aPP)
                  //
                  //    Cria ::oDlg hidden a fim de exigir executar o mtodo :show()
                  //         depois de acrescentar as colunas em CabBrowse_()
                  //         com ::XbpBrowse:currentSize(){01]
          if oParent == NIL
             oParent := AppDesktop()
          endif
          ::XbpDialog:init(oParent, oOwner, aPos, aSize, aPP, .f.)
          ::XbpDialog:border        := cabBROW_DLG_BORDER
          ::XbpDialog:icon          := cabWIN_ICON_TITLE
          ::XbpDialog:moveWithOwner := .t.
          ::XbpDialog:taskList      := .t.

          ::oBoxDetail              := XbpStatic():new(::XbpDialog:drawingArea, ::XbpDialog:drawingArea,;
                                                                                NIL,;
                                                                                NIL,;
                                                                                ::aPPDetails, .f.)
          ::oBoxDetail:type         := XBPSTATIC_TYPE_RECESSEDBOX

          ::oDetail                 := XbpStatic():new(::oBoxDetail, ::oBoxDetail,;
                                                                     {3, 3},;
                                                                     NIL,;
                                                                     ::aPPDetails, .t.)
          ::oDetail:autoSize := .t.
          ::oDetail:type     := XBPSTATIC_TYPE_TEXT
          ::oDetail:options  := XBPSTATIC_TEXT_LEFT
          ::nDetailsHeight   := 0
          ::oOldApp          := SetAppWindow()
          ::oHadFocus        := SetAppFocus()
          ::nMaxWidth        := MainAppWindow_():clientSize[01]
   RETURN Self

   INLINE METHOD Create()
          ::XbpDialog:create()
          ::XbpDialog:setModalState(XBP_DISP_SYSMODAL)
          ::XbpDialog:drawingArea:setPresParam(::XbpDialog:setPresParam())
          ::XbpDialog:drawingArea:setColorBg(::XbpDialog:setColorBg())
          ::XbpDialog:drawingArea:setColorFg(::XbpDialog:setColorFg())
   RETURN Self

   INLINE METHOD close()
          if Eval(::bClose)
             ::oBrowse:destroy()
          endif
   RETURN Self

   INLINE METHOD destroy()
          ::bClose         := NIL
          if ::oBoxDetail  <> NIL
             ::oBoxDetail:destroy()
             ::oBoxDetail := NIL
          endif
          if ::oPushBarr   <> NIL
             ::oPushBarr:destroy()
          endif
          if ::oBoxDetail  <> NIL
             ::oBoxDetail:destroy()
             ::oBoxDetail := NIL
          endif
          ::oDetail        := NIL
          ::nDetailsHeight := NIL
          ::oBrowse        := NIL
          ::oPushBarr      := NIL
           SetAppWindow(::oOldApp)
           SetAppFocus(::oHadFocus)
          ::oOldApp        := NIL
          ::oHadFocus      := NIL
   RETURN ::XbpDialog:destroy()

   INLINE METHOD show()
          LOCAL  lOk
          if !::XbpDialog:isVisible()
             lOk := ::Xbpdialog:show()
          else
             lOk :=.f.
          endif
          if ::oPushBarr  <> NIL      .and.;
             !::oPushBarr:isVisible()
             ::oPushBarr:show()
          endif
          if ::oBoxDetail <> NIL      .and.;
             !::oBoxDetail:isVisible()
             ::oBoxDetail:show()
          endif
          if ::oDetail    <> NIL      .and.;
             !::oDetail:isVisible()
             ::oDetail:show()
          endif
   RETURN lOK

   INLINE METHOD setPos(aNewPos)
          LOCAL  lOk
          if ::XbpDialog:setPos(aNewPos)
             lOk := .t.
          else
             lOk := .f.
          endif
   RETURN lOk

   INLINE METHOD drawitem(aOldSize, aNewSize)        // Depende de <aSize> informado ser <> NIL e Self:border ser resizeable
          ::XbpDialog:resize(aOldSize, aNewSize)
          ::oBrowse:CheckBrowseSize(aOldSize)
   RETURN Self

   INLINE METHOD createPushBarr(aPushButtons)
          cabPUSH   PUSHBARR      ::oPushBarr;
                    NEW           Self:drawingarea;
                    PUSHBUTTONS   aPushButtons;
                    CREATE
          ::nDetailsHeight += ::oPushBarr:currentSize()[02]
   RETURN ::oPushBarr

   INLINE METHOD showDetailCreate(cCaption)
          LOCAL  aBoxSize, aDetailSize, aPos

          ::oBoxDetail:create()
          ::oDetail:caption := cCaption
          if (CR $ cCaption) .or.;
             (LF $ cCaption)
             ::oDetail:options += XBPSTATIC_TEXT_WORDBREAK
          endif
          ::oDetail:create()
          aBoxSize         := ::XbpDialog:clientSize
          aPos             := {0, aBoxSize[02]}
          aDetailSize      := ::oDetail:currentSize()
          aDetailSize[01]  := (aBoxSize[01]    - 6)
          aBoxSize[02]     := (aDetailSize[02] + 6)
          aPos[02]         -= aBoxSize[02]
          if ::oPushBarr   <> NIL
             aPos[02]      -= ::oPushBarr:currentSize()[02]
          endif
          ::oBoxDetail:setPosAndSize(aPos, aBoxSize)
          ::oDetail:setSize(aDetailSize)
          ::nDetailsHeight += aBoxSize[02]
   RETURN ::oBoxDetail

   INLINE METHOD setPosPushBarr()
          if ::oPushBarr <> NIL
             ::oPushBarr:setPos({0, (::XbpDialog:clientsize[02] - ::oPushBarr:currentSize()[02])})
          endif
   RETURN NIL

   INLINE METHOD setPosShowDetail()
          ::oBoxDetail:setPos({0, (::XbpDialog:clientSize[02]   - ::nDetailsHeight)})
   RETURN NIL

   INLINE METHOD showDetail(cCaption)
          ::oDetail:setCaption(cCaption)
   RETURN cCaption

ENDCLASS

 ////////////
 //
CLASS CabBrowse_ FROM XbpBrowse
 //
 //   Classe para a criao de XbpBrowse() com colunas de mltiplas linhas.
 //
 //    composta de dois objetos:
 //     . CabDlgBrowse_() derivada de XbpDialog() que  o "container" de Self
 //       .. pode conter um objeto da classe CabPushBarr_() que  uma barra de
 //          pushButtons e  inicializada e criada pelos mtodos ::oDlg:initPushBarr()
 //          e ::oDlg:createPushBarr(aPushButtons)
 //          Os mtodos para processar a barra de pushbuttons esto codificados
 //          em CabBrowse_() e so:
 //          ::enableBarr())
 //          ::disableBarr()
 //          ::enablePush(nPush)
 //          ::disablPush(nPush)
 //       .. Contm um objeto da classe XbpStatic() usado para identificar a linha
 //          corrente de Self e um objeto opcional da classe CabPusBarr_()
 //       .. Apenas seus mtodos :init(), :create() e :close() so executados
 //          em CabDlgBrowse_().
 //       .. Como o retorno de CabBrowse_()  um objeto da classe XbpBrowse()
 //          a execuo de mtodos da classe CabDlgBrowse_() (Self:oDlg)
 //          so executados atravs de Self
 //
 //     . XbpBrowse()
 //       .. executa os mtodos necessrios para o controle de CabDlgBrowse_()
 //       .. Pode-se usar PostAppEvent(cabEVENT_EXIT) para se encerrar o ::eventLoop()
 //          sem executar os parmetros <bClose> e <bEscExit>.
 //          Neste caso o retorno de CabBrowse_ ser GE_ESCAPE
 //       .. existe o mtodo CabBrowse_:eventLoop(nModalState) para ser executado e
 //          retornar o controle ao aplicativo.
 //          Deve ser usado, por exemplo, quando cabBrowse_()  intercalado com
 //          XbpGet() e receber o foco de XbpGetController().
 //          Neste caso retorna CabBrowse_:ExitStatus da mesma forma que XbpGetController()
 //       ..  importante acrescentar as colunas predefinidas para Self
 //          antes de executar o mtodo ::create() para que os parmetros
 //          de redimensionamento de Self sejam executados com correo.
 //          Quando se tem mltiplas linhas no cabealho e/ou ropdap o respectivo
 //          array descritivo da primeira coluna tem de retornar a quantidade de linhas
 //          Aps a execuo mtodo CabBrowse_:create() tem-se de executar o
 //          mtodo CabBrowse_:show()
 //          . Pode-se acrescentar e eliminar colunas normalmente aps a execuo
 //            do mtodo CabBrowse_:create()
 //       .. caso seja imprescindvel acrescentar as colunas iniciais depois
 //          do mtodo ::create() tem-se de executar o mtodo ::checkMySize()
 //          para processar as iVars ::lAutoSizeWidth, ::lAutoSizeHeight e
 //          ::lResize
 //
 //   RETORNA ::exitStatus:
 //           . GE_WRITE   -> o processamento foi encerrado corretamente
 //           . GE_ESCAPE  -> o processamento foi cancelado
 //
 //   ATENO: o call back slot :RbDown  usado para exibir o menu "Meu Assistente".
 //            Os call back slots :headerRbDown ::itemRbDown e :footerRbDown so inicializados para
 //            exibir o menu "Meu Assistente".
 //            ATENO: se o evento xbeM_RbDown for referenciado no loop de controle de
 //            Self e os call back slots xbeBRW_HeaderRbDown, xbeBRW_ItemRbDown, ou
 //            xbeBRW_FooterRbDown forem utilizados ele ser gerado tambm.
 //
 //   INFORMAO: uma coluna  formada por 3 partes, em um nico objeto da classe XbpColumn():
 //               cabealho, dados e rodap (XbpColumn:heading, XbpColumn:dataArea e XbpColumn:footing).
 //               Os dados a serem exibidos em cada rea so obtidos por objetos especficos contidos
 //               nas variveis acima e so da classe XbpCellGroup().
 //
 //               Para viabilizar exibir o browse com mais de uma linha no cabeaho, rea de dados e/ou
 //               rodap, foi criada a classe MultiLineCol_(), derivada de XbpColumn(), e a
 //               classe MultilineCell_() (derivada de XbpCellGroup()) para processar cada rea.
 //
 //               Os parmetros de apresentao da coluna esto definidos na varivel cabBROW_PP_COLS
 //               onde existem os seguintes itens que precisam ser redefinidos para cada coluna:
 //                    XBP_PP_COL_HA_CAPTION         -> string ou array do cabealho
 //                    XBP_PP_COL_DA_CHARWIDTH       -> extenso da coluna em caracteres
 //                                                     (vide [<nWidth>])
 //                    XBP_PP_COL_DA_ROWHEIGHT       -> altura de cada linha da coluna
 //                    XBP_PP_COL_FA_CAPTION         -> string ou array do rodap
 //
 //               Quando se opta por encerrar a sesso pela opo 'Encerrar' do "Meu Assistente"
 //               ::ExitStatus  feito := GE_WRITE para o encerramento de ::XbpBrowse()
 //               ATENO: a primeira coluna a ser includa determina quantas linhas cada rea
 //                        (header, data, foot) vai ter.
 //                        O primeiro item do array do cabealho e do rodap determinam a extenso
 //                        da coluna caso o parmetro [<nWidth>] no for definido.
 //
 //   EXCESSO: caso se deseje usar imagens no cabealho ou rodap as classes MultiLineCol_() e
 //             ::customDrawCell() precisam serem modificadas para exibir objeto da classe
 //             XbpBitmap() em vez de GraStrCaption().
 //
 //  INTEGRAO COM XbpGet:
 //             . os parmetros <bSelectedRow>, <bHitTop>, <bHitBottom>, <bClose>
 //               e <bEscExit> precisam ser codificados para integrao com
 //               XbpGetController()
 //             . O encerramento de Self faz a iVar ::ExitStatus == GE_WRITE ou
 //                 ::ExitStatus == GE_WRITE       
 //
 //  GERAL:
 //             Existem duas variveis que representam os objetos desta Classe:
 //             . ::oDlg    -> refere-se  CabDlgBrowse_() que  a container de Self
 //             . ::oBrowse -> objeto da classe XbpBrowse() que apresenta os dados
 //
 //
 //   :new([<oParent>], [<oOwner>], [<aPos>], [<aSize>], [<aPP>], [<lVisible>])
 //        Os parmetros so relativos  uma CabDlBrowse_()
 //           [<oParent>]   -> refere-se a <oParent> de CabDlgBrowse_().
 //                            Caso CabDlgBrowse_() possua menu de barras, <oParent> tem de
 //                            ser AppDesktop(). CabDlgBrowse_() pode ser reposicionado em
 //                            qualquer janela usando o mtodo CabBrowse_:setPosInXbp(<oXbp>, <xPos>)
 //                            Assume: AppDesktop()
 //           [<oOwner>]    -> owner para CabDlgBrowse_()
 //                            Assume SetApWindow()
 //           [<aPos>]      -> posio de CabDlgBrowse_() em <oParent>
 //                            Caso se informe a posio deve-se informar <aSize> ou
 //                            se no informado Self ser posicionado sempre no canto
 //                            superior esquerdo de MainAppWindow_(cabWIN_DRAW)
 //                            Veja o mtodo ::setPosInXbp(<oXbp>, <xPos>)
 //           [<aSize>]     -> tamanho da CabDlgBrowse_()
 //                            . Se <aSize> for informado tem de incluir a altura da barra
 //                              de ttulo, bordas, menu de barras e barra de pushbuttons
 //                              Pode-se usar os parmetros <lAutoSizeWidth> e
 //                              <lAutoSizeHeight> para ajustar a largura e a altura 
 //                              de CabDlgBrowse_()
 //                            Assume: . a largura de AppDesktop()
 //                                    . a altura ocupada por MainAppWindow_() mais sua
 //                                      posio inicial - MainAppWindow_():clientSize[02]
 //                                    . assume-se os parmetros <lAutoSizeWidth> e 
 //                                      <lAutoSizeHeight> := .t. para se ajustar a largura
 //                                      de ::XbpBrowse()  extenso das colunas e a altura
 //                                       necessria para exbir apenas as linhas com dados.
 //           [<aPP>]       -> presentation parameter para XbpDialog().
 //                            Assume cabBROW_PP_DIALOG.
 //                            Caso se deseje alterar algum parmetro faa com CabBrowse:set...
 //           [<lVisible>]  -> ser sempre .f.
 //                            Isto  para exigir que se execute CabBrowse_:show() aps a
 //                            incluso das colunas para que o tamanho de XbpBrowse seja
 //                            ajustado conforme acima.
 //   RETORNA ::exitStatus
 //
 //   :initIvars(;
 //                              //
 //                              //   Parmetros de CabDlgBrowse_() (::oDlg)
 //        [[<lTitleBar>], <nIcon>],    [<cTitle>], [<lTaskList>], [<lMinButton>],;
 //        [<lMaxButton>], [<nBorder>], [<bClose>], [<bEscExit>],;
 //        [<aMenuBarIens>],;
 //                              //
 //                              //   PushButtons para criar a barra de pushbuttons abaixo
 //                              //               do menu
 //        [<aPushButtons>],;
 //                              //   Array contendo os blocos de cdigos de movimentao.
 //                              //   Vide cabBROW_IND_... em CabDefs.ch
 //        <aSkipInSource>,;
 //                              //
 //                              //   Configurao
 //        [<nCursorMode>],  [<lHScroll>],     [<lVScroll>],;
 //        [<bHitTop>],      [<bHitBottom>],   [<lReSizeCols>],;
 //        [<aLeftFrozen>],  [<aRightFrozen>],;
 //        [<bRowDetail>],   [<lShowMovement>];
 //                              //
 //                              //   Edio
 //        [<bSelectedRow>],;
 //                              //
 //                              //   Presentation prameters para as colunas
 //        [<aPPCols>])
 //                              //
 //                              //   Descrio dos itens
 //        [<lTitleBar>]       -> exibir a barra de ttulos?
 //                               Se .f. os parmetros <cTitle>, <lMinButton> e <lMaxButton>
 //                                      sero ignorados                                                    
 //                               Assume .t.                                                                
 //        [<nIcon>]           -> assume cabWIN_ICON_TITLE                                                  
 //        [<cTitle>]          -> no assume                                                                
 //        [<lTaskList>]       -> assume .t.                                                                
 //        [<lMinButton>]      -> assume .t.
 //        [<lMaxButton>]      -> assume .t.
 //        [<nBorder>]         -> borda de Self.
 //                              assume cabBROW_DLG_BORDER
 //
 //        [<bClose>]          -> bloco de cdigos a ser executado durante o evento xbeP_Close.
 //                               Recebe como parmetros |Self, ::phyPosBlock, ::rowPos, ::colPos|.
 //                               Retorna: cabEVENT_CONTINUE -> ignora o evento
 //                                        cabEVENT_OK       -> encerra o processamento e
 //                                                             faz ::ExitStatus := GE_WRITE
 //                               Assume: cabBROW_CONTINUE
 //        [<bEscExit>]        -> bloco de controle do evento xbeK_ESC
 //                               Recebe como parmetros |Self, ::phyPosBlock, ::rowPos, ::colPos|.
 //                               Retorna: cabEVENT_CONTINUE -> ignora o evento
 //                                        cabEVENT_ESCAPE   -> encerra o processamento e
 //                                                             faz ::ExitStatus := GE_ESCAPE
 //                               Assume: cabROW_EXITESC
 //        [<MenubarItens>     -> itens para se ncluir no menu de barras de CabDglBRowse_()
 //                               Existem em Self mtodos especficos criados com a mesma sintaxe dos
 //                               mtodos de XbpMenubar() para serem referenciados pelo aplicativo
 //                               Ex.: oBrowse:addItem(aItem)
 //        [<aPushButtons>]    -> array contendo os PushButtons para formar a barra de PushButtons
 //                               a ser exibida abaixo do menu, no formato:
 //                               {;
 //                                {<nIcon>, <bActivate>, [<cTip>], [<lEnabled>]},;
 //                                {<nIcon>, <bActivate>, [<cTip>], [<lEnabled>]},;
 //                                NIL | "',;
 //                               }
 //                               . descrio em CabPushBar.prg
 //                               Vide cabPUSH PUSHBARR ...
 //                               . a barra de pushbuttons  criada pelos mtodos
 //                                 ::oDlg:newPushBarr() e ::oDlg:createPushBarr(<aPushButtons>)
 //                               . os mtodos de configurao da barra de pushbuttons
 //                                 esto em Self e iniciam por
 //         <aSkipInSource>    -> blocos de cdigos para a movimentao na fonte de dados e
 //                               de posicionamento das barras de movimentao.
 //                               Devem ser especificados conforme as constantes
 //                               cabBROW_IND_...
 //                               Importante especificar o item cabBROW_IND_GOPHYPOSBLOCK porque
 //                               ele  passado como parmetro para diversos mtodos.
 //        [<nCursorMode>]     -> modo mostrar a posio do cursor no browse.
 //                               Assume XBPBRW_CURSOR_CELL
 //        [<lHScroll>]        -> exibir a barra de movimento horizontal?
 //                               Assume .t.                                                                
 //        [<lVScroll>]        -> Exibir a barra de movimentao vertical?                                  
 //                               Assume .t.
 //        [<bHitTop>]         -> bloco de cdigos para ser executado quando se tenta mover
 //                               acima da primeira linha.
 //                               Recebe como parmetros |Self, ::phyPosBlock, ::rowPos, ::colPos|.
 //                               Pode retornar: cabEVENT_OK        -> encerra  o processamento e faz ::ExitStatus := GE_WRITE
 //                                              cabEVENT_CONTINUE  -> continua o processamento
 //                                              cabEVENT_ESCAPE    -> encerra  o processamento e faz ::ExitStatus := GE_ESCAPE
 //        [<bHitBottom>]      -> bloco de cdigos para ser executado quando se tenta mover
 //                               abaixo da ltima linha.
 //                               Recebe como parmetros |Self, ::phyPosBlock, ::rowPos, ::colPos|.
 //                               Pode retornar: cabEVENT_OK        -> encerra  o processamento e faz ::ExitStatus := GE_WRITE
 //                                              cabEVENT_CONTINUE  -> continua o processamento
 //                                              cabEVENT_ESCAPE    -> encerra  o processamento e faz ::ExitStatus := GE_ESCAPE
 //                               Assume cabBROW_OVERFLOW
 //        [<lAutoSizeWidth>]  -> ajustar a extenso das linhas  soma das extenso das colunas?
 //                               Assume .t.
 //        [<lAutoSizeHeight>] -> ajustar a quantidade de linhas (::rowCount) de dados
 //                               para exibir apenas aquelas que contm dados?
 //                               Usada apenas ao se estabilizar ::XbpBrowse na primeira vez.
 //                               Se for necessrio executar novamente fazer <lAutoSizeHeight> := .t.
 //                               e executar o mtodo Self:checkMySize()
 //                               Assume .t.
 //        [<lReSizeCols>]     -> a extenso das colunas pode ser modificada pelo mouse?
 //                               Assume .t.
 //        [<aLeftFrozen>]     -> array contendo as colunas para serem "congeladas"
 //                                esquerda de Self no formato {nstart,...}
 //                               Exemplo: {01}    congela a  coluna  1
 //                                        {01,02} congela as colunas 1 e 2
 //                               Assume NIL
 //        [<aRightFrozen>]    -> array contendo as colunas para serem "congeladas"
 //                                direita de Self no formato {(nLast-n), nLast}
 //                               Exemplo: {oBrowse:colCount} congela a ltima coluna
 //                                        {(oBrowse:colCount - 1), oBrowsecolCount}
 //                               Assume NIL
 //        [<bRowDetail>]      -> bloco de cdigos que retorna um string com uma ou mais
 //                               linhas contendo informaes a serem exibidas acima do cabealho
 //                               de Self quando a linha receber o foco.
 //                               A separao de linhas pode ser feita por Chr(13) e/ou Chr(10).
 //                                ativado por Self:stableBlock()
 //                               . Recebe como parmetros |Self, ::phyPosBlock, ::rowPos, ::colPos|.
 //                               Assume NIL.
 //        [<lShowMovement>]   -> s exibir as linhas do browse quando finalizar o movimento
 //                               da barra de rolagem?
 //                               Assume .f.
 //        [<bSelectedRow>]    -> bloco de cdigos para indicar que a linha ::rowPos foi marcada ou
 //                               selecionada.
 //                               . xbeM_LbDblClick (::dataArea:itemSelected) assume cabBROW_SELECTEDROW
 //                               . xbeK_ENTER      (::dataArea:itemSelected) assume cabBROW_SELECTEDROW
 //                               . xbeM_LbDown     (::dataArea:itemMarked)   assume cabBROW_MARKEDROW
 //                               . Recebe como parmetros |Self, ::phyPosBlock, ::rowPos, ::colPos|.
 //                               O retorno de <bSelectedRow>  ignorado
 //        [<aPPCols>]          -> Presentation Parameters para as colunas de Self.
 //                                Se for modificar usar a mesma ordem dos itens que cabBROR_PP_COLS
 //   :create()
 //           Aloca os recursos sem exibir os objetos.
 //           EXECUTAR DEPOIS da ltima coluna adicionada.
 //   RETORNA Self
 //                              //
 //                              //     Descrio das colunas
 //   Mtodo :addColumn(<xLink>, [<cPicture>], [<nWidth>], [<xHeader>], [<xFoot>],;
 //                              [<nType>],    [<cName>])
 //           <xLink>          -> poder ser:
 //                               . um objeto da classe XbpColumn():
 //                                 .. se     for derivada de CabCol_, ser vinculada a Self
 //                                 .. se no for derivada de CabCol_, ser includa em Self
 //                               . um bloco de cdigos para se exibir os dados da fonte de dados
 //                                 Pode retornar um array com os dados a apresentar ou um string
 //          [<cPicture>]      -> picture para a edio dos dados.
 //                               Ignorada se Eval(XbpColumn():dataLink) retornar um array.
 //                               Assume ''
 //          [<n/width>]       -> quantidade de caracteres para definir a extenso da coluna.
 //                               Assume a maior quantidade de caracteres entre o cabealho,
 //                               raea de dados e o rodap
 //          [<xHeader>]       -> Cabealho da coluna. 
 //                               . se for um array ser criado por MultilineCell_()
 //                               . se for NIL a coluna no ter cabealho
 //                               . o parmetro <xHeader> da primeira coluna define a quantidade
 //                                 de linhas que ser usada por todas as colunas.
 //                               . os parmetros <xHeader> subsequentes tero sua quantidade de
 //                                 linhas ajustadas s do primeiro
 //                               Assume NIL.
 //          [<xFoot>]         -> Rodap da coluna.
 //                               Idem <xHeader>
 //          [<nType>]         -> tipo da coluna conforme XBPCOL_TYPE_
 //                               Assume: XBPCOL_TYPE_TEXT
 //          [<cName>]         -> nome para identificar a coluna. Usado para localizar a coluna em
 //                               CabBrowse_:rowPos, quando CabBrowse_:colPos  desconhecido.
 //                               No  "case sensitive".
 //                               Fica armazenado na varivel Xbpcolumn():cName
 //                               Assume ''
 //   RETORNA oColumn
 //
 //   Analista:    Beling
 //   Programador: Bento

PROTECTED:
   CLASS VAR  aPPDialog           SHARED  // Usadas para performance
   CLASS VAR  aPPColumns          SHARED
   CLASS VAR  aPPDetails          SHARED
   CLASS VAR  aOptions            SHARED  // Opes para o Menu Popup

   VAR        oPopUp
   VAR        aMenubarItens
   VAR        nHeaderLines
   VAR        nFootLines
   VAR        aPushButtons

EXPORTED:   
   VAR        oDlg           READONLY     // CabDlgBrowse_()
   VAR        oBrowse        READONLY     // Self
   VAR        aPPCol                      // XbpCol() presentation parameters (::aPPColumns modificada)
   VAR        bEscExit       READONLY     // Finalizar o processamento teclando-se <ESC>
   VAR        oMenuBar                    // Objeto da classe CabMenubar_()

   VAR        bRowDetail                  // Identificao do contedo da linha que tem o foco
   VAR        nInterline                  // Altura de uma linha da XbpColumn():dataArea

   VAR        nRowWidth                   // Extenso da linha de ::XbpBrowse para redimensionar ::oDlg
   VAR        nMinWidth                   // Menor extenso de ::XbpBrowse:currentSize()[01]
   VAR        lSetPosOnTop
   VAR        lAutoSizeWidth              // Redimensionar a extenso da linha  soma das extenses das colunas
   VAR        lAutoSizeHeight             // Redimensionar pela primeira vez que apenas as linhas que
                                             // contenham dados sejam exibidas
   VAR        lResize                     // A extenso da linha de ::XbpBrowse foi modificada
                  //
                  //    Commpatibilizao com XbpGetController()
   VAR        exitStatus                  // Informao sobre o encerramento de Self
   VAR        controller                  // Usada para receber o foco atravs de XbpBetController:read

   METHOD         init()
   METHOD         initIVars()
   METHOD         create()
   METHOD         formatColumn()
   METHOD         customDrawCell()

   INLINE CLASS METHOD initClass()
          ::XbpBrowse:initClass()
          ::aPPDialog          := cabBROW_PP_DIALOG
          ::aPPColumns         := cabBROW_PP_COLS
          ::aPPDetails         := cabBROW_PP_DETAILS
                  //
                  //    Opes do "Meu Assistente"
          ::aOptions  := {{'Encerrar',                                {|| PostAppEvent(xbeP_Keyboard, cabEVENT_EXIT, NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_CANCEL16x16},;
                          {NIL,                                       NIL,;
                                                                      NIL,;
                                                                      NIL,;
                                                                      XBPMENUBAR_MIS_SEPARATOR},;
                          {'Atualizar a Tela',                        {|| ::oDlg:invalidateRect()},;
                                                                      NIL,;
                                                                      cabICO_RELOAD16x16},;
                          {'Primeira Tela'   + Chr(09) + 'Ctrl+PgUp', {|| PostAppevent(xbeP_Keyboard, xbeK_CTRL_PGUP, NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_PRIMEIRATELA16x16},;
                          {'ltima Tela'     + Chr(09) + 'CTRL+PgDn', {|| PostAppevent(xbeP_Keyboard, xbeK_CTRL_PGDN, NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_ULTIMATELA16x16},;
                          {'Tela Acima'      + Chr(09) + 'PageUp',    {|| PostAppevent(xbeP_Keyboard, xbeK_PGUP,      NIL, Self)},;
                                                                      NIL,;
                                                                       cabICO_TELAACIMA16x16},;
                          {'Tela Abaixo'     + Chr(09) + 'PageDown',  {|| PostAppevent(xbeP_Keyboard, xbeK_PGDN,      NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_TELAABAIXO16x16},;
                          {'Incio da Linha' + Chr(09) + 'Home',      {|| PostAppevent(xbeP_Keyboard, xbeK_HOME,      NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_INICIODALINHA16x16},;
                          {'Final da Linha'  + Chr(09) + 'End',       {|| PostAppevent(xbeP_Keyboard, xbeK_END,       NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_FIMDALINHA16x16},;
                          {'Linha Acima'     + Chr(09) + 'Up',        {|| PostAppevent(xbeP_Keyboard, xbeK_UP,        NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_ARROWBLUEUP16x16},;
                          {'Linha Abaixo'    + Chr(09) + 'Down',      {|| PostAppevent(xbeP_Keyboard, xbeK_DOWN,      NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_ARROWBLUEDOWN16x16},;
                          {'Esquerda'        + Chr(09) + 'Left',      {|| PostAppevent(xbeP_Keyboard, xbeK_LEFT,      NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_ARROWBLUELEFT16x16},;
                          {'Direita'         + Chr(09) + 'Right',     {|| PostAppevent(xbeP_Keyboard, xbeK_RIGHT,     NIL, Self)},;
                                                                      NIL,;
                                                                      cabICO_ARROWBLUERIGHT16x16},;
                          {NIL,                                       NIL,;
                                                                      NIL,;
                                                                      NIL,;
                                                                      XBPMENUBAR_MIS_SEPARATOR},;
                          {'Sair'            + Chr(09) + 'Esc',       {|| PostAppevent(xbeK_ESC)},;     //  para o "Meu Assistente"
                                                                      NIL,;
                                                                      cabICO_SAIR16x16}}
   RETURN Self

   INLINE  METHOD destroy()
           ::oDlg:browse := NIL
           ::oDlg:destroy()
   RETURN ::XbpBrowse:destroy()
                  //
                  //    Mtodos processados por ::oDlg (::XbpBrowse:setParent())
   INLINE METHOD close()
   RETURN ::oDlg:close()

   INLINE METHOD hide()
   RETURN ::oDlg:hide()

   INLINE METHOD show()
   RETURN ::oDlg:show()

   INLINE METHOD isEnabled()
   RETURN ::oDlg:isEnabled()

   INLINE METHOD isVisible()
   RETURN ::oDlg:isVisible()

   INLINE METHOD enable()
          LOCAL  lOk
          if !::oDlg:isEnabled()
             lOk := ::oDlg:enable()
          else
             lOk := .f.
          endif
   RETURN lOk

   INLINE METHOD Disable()
          LOCAL  lOk
          if ::oDlg:isEnabled()
             lOk := ::oDlg:disable()
          else
             lOk := .f.
          endif
   RETURN lOk

   INLINE METHOD toBack()
   RETURN ::oDlg:toBack()
   
   INLINE METHOD toFront()
   RETURN ::oDlg:toFront()

   INLINE METHOD currentPos()
   RETURN ::oDlg:currentPos()

   INLINE METHOD currentSize()
   RETURN ::oDlg:currentSize()

   INLINE METHOD setSize(aNewSize, aOldSize)
          if aOldSize == NIL
             aOldSize := ::oDlg:currentSize()
          endif
          if aNewSize[01]   <> aOldSize[01] .or.;
             aNewSize[02]   <> aOldSize[02]
             ::oDlg:setSize(aNewSize)
//             ::oDlg:setPosPushBarr()
//             ::oDlg:setPosShowDetail()
             ::checkBrowseSize(aOldSize)
          endif
   RETURN .t.

//   INLINE METHOD reSize(aOldSize, aNewSize)      // S ocorre em CabDlgBrowse_()

   INLINE METHOD checkBrowseSize(aOldSize)
          LOCAL  aClientSize

          aClientSize        := ::oDlg:clientSize
          if aClientSize[02] <> aOldSize[02] .or.;
             aClientSize[01] <> aOldSize[01]
             if     ::oDlg:oPushBarr         <> NIL
                    ::oDlg:nDetailsHeight    := ::oDlg:oPushBarr:currentSize()[02]
                    ::oDlg:oPushBarr:setPos({0, (aClientSize[02]     - ::oDlg:oPushBarr:currentSize()[02])})
                    if ::oDlg:oBoxDetail     <> NIL
                       ::oDlg:nDetailsHeight += ::oDlg:oBoxDetail:currentSize()[02]
                       ::oDlg:oBoxDetail:setPos({0, (aclientSize[02] - ::oDlg:nDetailsHeight)})
                       ::oDlg:oBoxDetail:invalidaterect()
                    endif
             elseif ::oDlg:oBoxDetail        <> NIL
                    ::oDlg:nDetailsHeight    := ::oDlg:oBoxDetail:currentSize()[02]
                    ::oDlg:oBoxDetail:setPos({0, (aclientSize[02]    - ::oDlg:nDetailsHeight)})
             else
                    ::oDlg:nDetailsHeight    := 0
             endif
             aClientSize[02] -= ::oDlg:nDetailsHeight
             ::XbpBrowse:setSize(aClientSize)
          endif
   RETURN NIL

   INLINE METHOD setPosAndSize(aNewPos,aNewSize, oXbp)
          ::setSize(aNewSize)
   RETURN ::setPosInXbp(oXbp, aNewPos)

   INLINE METHOD setPosInXbp(oXbp, xPos)
          LOCAL  aNewPos, nMyHeight, nXbpHeight

          if oXbp == NIL
             oXbp := MainAppWindow_()
          endif
          if xPos == NIL
             xPos := cabPOS_TOP
          endif
          if     ValType(xPos) == 'A'
                 aNewPos       :=  CalcXbpAbsPos_(oXbp)
                 ::oDlg:setPos({(aNewPos[01] + xPos[01]),;
                                (aNewPos[02] + xPos[02])})
                 ::lSetPosOnTop := .f.
          elseif xPos          == cabPOS_TOP
                 if oXbp       == AppDesktop()
                    oXbp       := MainAppWindow_()
                 endif
                 aNewPos       := CalcXbpAbsPos_(oXbp)
                 nMyHeight     := ::oDlg:currentSize()[02]
                 nXbpHeight    := oXbp:currentSize()[02]
                 if IsMethod(oXbp, 'ClientSize')
                    nXbpHeight -= (oXbp:currentSize()[02] - oXbp:clientSize[02])
                 endif
                 aNewPos[02] += (nXbpHeight - nMyHeight)
                 ::oDlg:setPos(aNewPos)
                 ::lSetPosOnTop := .t.
          elseif xPos == cabPOS_CENTER
                 CenterControl(::oDlg, oXbp)
                 ::lSetPosOnTop := .f.
          endif
   RETURN NIL

   INLINE METHOD checkMySize()
          LOCAL  aNewSize, aBrowSize, nRowHeight, nRowCount, oCol
                  //
                  //   Extenso da linha
          if ::lResize
             ::lResize      := .f.
             if ::lAutoSizeWidth                            .and.;
                ::nRowWidth <> ::XbpBrowse:currentSize()[01]
                  //
                  //    Maior e menor extenses possveis da drawingArea
                aBrowSize := ::XbpBrowse:currentSize()
                aNewSize  := ::XbpBrowse:currentSize()

                if     ::nRowWidth    > ::oDlg:nMaxWidth
                       aNewSize[01]  := ::oDlg:nMaxWidth
                elseif ::nRowWidth    < ::nMinWidth
                        aNewSize[01] := ::nMinWidth
                endif
             endif
          endif
                  //
                  //    Quantidade de linhas apresentando dados
          if ::lAutoSizeHeight
             ::lAutoSizeHeight := .f.
             if aNewSize   == NIL
                aBrowSize  := ::XbpBrowse:currentSize()
                aNewSize   := ::XbpBrowse:currentSize()
             endif
             oCol          := ::XbpBrowse:getColumn(1)
             nRowHeight    := oCol:currentSize()[02]
             for nRowCount := ::XbpBrowse:rowCount to 2 Step -1
                 if oCol:dataArea:getCell(nRowCount) <> NIL
                    exit
                 endif
                 aNewSize[02] -= nRowHeight
             next
             if aNewSize[02]   < nRowHeight
                aNewSize[02]  := (nRowHeight + ApiGetScrollBarXHeight_())
             endif
          endif

          if (aNewSize         <> NIL                .and.;
              (aNewSize[01]    <> aBrowSize[01] .or.;
               aNewSize[02]    <> aBrowSize[02]))
             ::XbpBrowse:setSize(aNewSize)
             aNewSize[02]      += ::oDlg:nDetailsHeight
             ::oDlg:clientSize := aNewSize
             ::oDlg:setPosPushBarr()
             ::oDlg:setPosShowDetail()
                  //
                  //    Reposiciona
             if ::lSetPosOnTop
                cabBROWSE  SETPOS    Self;
                           POSITION  cabPOS_TOP
             endif
          endif
   RETURN NIL

   INLINE METHOD keyboard(nKeyCode)
          if     nKeyCode    == cabEVENT_EXIT
                 ::destroy()
          elseif nKeyCode    == xbeK_ESC
                 PostAppEvent(xbeP_Keyboard, xbeK_ESC)
          endif
   RETURN Self

   INLINE METHOD eventLoop(nModalState)
          LOCAL  nOldState, oHadFocus, nEvent, mp1, mp2, oXbp

          nOldState      := ::oDlg:getModalState()
          if nModalState == NIL
             nModalState := nOldState
          endif
          if nModalState <> nOldState
             ::oDlg:setModalState(nModalState)
          endif
          oHadFocus    := SetAppFocus(::oDlg)
          ::ExitStatus := cabEVENT_CONTINUE
          do while ::ExitStatus == cabEVENT_CONTINUE
             nEvent             := AppEvent(@mp1, @mp2, @oXbp)
             oXbp:handleEvent(nEvent, mp1, mp2)
             if     nEvent       == cabEVENT_EXIT   .or.;
                    nEvent       == cabEVENT_ESCAPE
                    ::ExitStatus := GE_ESCAPE
             elseif nEvent       == cabEVENT_OK
                    ::ExitStatus := GE_WRITE
             endif
          enddo
          if ::oDlg:getModalState() <> nOldState
             ::oDlg:setModalState(nOldState)
          endif
          SetAppFocus(oHadFocus)
   RETURN Self

   INLINE METHOD exeCallBack(bBlock)
          LOCAL xReturn
          xReturn := Eval(bBlock, Self, ::XbpBrowse:rowPhyPos, ::XbpBrowse:rowPos, ::XbpBrowse:colPos)
          if ::controller            <> NIL .and.;
             ValType(xReturn)        == 'N'
             ::controller:exitStatus := ::exitStatus
          endif
   RETURN xReturn
                  //
                  //    Mtodos para a barra de pushbuttons
   INLINE METHOD disableBarr()
   RETURN ::oDlg:oPushBarr:disable()

   INLINE METHOD enableBarr()
   RETURN ::oDlg:oPushBarr:enable()

   INLINE METHOD disablePush(nPush)
   RETURN ::oDlg:oPushBarr:enablePush(nPush)

   INLINE METHOD enablePush(nPush)
   RETURN ::oDlg:oPushBarr:disablePush(nPush)
                  //
                  //    Mtodos para colunas
   INLINE METHOD delColumn(nColPos)
          LOCAL  oCol
          oCol        := ::XbpBrowse:getColumn(nColpos)
          ::nRowWidth -= oCol:currentSize()[01]
          ::lResize   := .t.
   RETURN ::XbpBrowse:delColumn(nColPos)

   INLINE METHOD addColumn(xLink, cPicture, nWidth, xHeading, xFooting,;
                                  nType, cName)
          LOCAL  oCol
          if ValType(xLink) == 'O'
             oCol           := xLink
             if oCol:setParent() <> Self
                oCol:setParent(Self)
             endif
          else
             oCol := ::formatColumn(xLink, cPicture, nWidth, xHeading, xFooting,;
                                           nType,    cName)
          endif
          oCol        := ::XbpBrowse:addColumn(oCol)
          ::nRowWidth += oCol:currentSize()[01]
          ::lReSize   := .t.
   RETURN oCol

   INLINE METHOD getCellData(nColPos)
          LOCAL  oCol
          oCol := ::oBrowse:getColumn(nColPos)
   RETURN Eval(oCol:dataLink)

   INLINE METHOD getRowData()
          LOCAL  nInd, oCol, aData

          if ::XbpBrowse:cursorMode == XBPBRW_CURSOR_ROW
             aData := ::XbpBrowse:getData()
          else
             aData    := {}
             for nInd := 1 to ::XbpBrowse:colCount
                 oCol := ::oBrowse:getColumn(nInd)
                 AAdd(aData, Eval(oCol:dataLink))
             next
          endif
   RETURN aData
                  //
                  //    Mtodos para menus
   INLINE METHOD menuBar()
   RETURN  ::oMenuBar

   INLINE METHOD popup(aMousePos)
   RETURN ::oPopup:popUp(::XbpBrowse, aMousePos, 1)

   INLINE METHOD disableMenuBar()
   RETURN ::oMenuBar:disable()

   INLINE METHOD enableMenubar()
   RETURN ::oMenuBar:enable()

   INLINE METHOD getItem(nOrd)
   RETURN ::oMenuBar:getItem(nOrd)

   INLINE METHOD isItemChecked(nOrd)
   RETURN ::oMenuBar:isItemChecked(nOrd)

   INLINE METHOD disableItem(nOrd)
   RETURN ::oMenuBar:disableItem(nOrd)

   INLINE METHOD enableItem(nOrd)
   RETURN ::oMenuBar:enableItem(nOrd)

   INLINE METHOD addItem(aItem)
          LOCAL  aOldSize
          aOldSize := ::oDlg:clientSize
          cabMENU  ::oMenuBar;
                   ADDITEM      aItem
                  //
                  //    Ajusta a altura de Self com a do menu de barras
          ::checkBrowseSize(aOldSize)
   RETURN ::oMenuBar:numItems()

   INLINE METHOD insItem(nOrd, aItem)
          LOCAL  aOldSize, lOk
          aOldSize := ::oDlg:clientSize
          cabMENU   ::oMenuBar;
                    INSITEM      aItem;
                    ORDEM        nOrd
          lOk := ::oMenuBar:insItem(nOrd, aItem)
                  //
                  //    Ajusta a altura de Self com a do menu de barras
          if lOk
             ::checkBrowseSize(aOldSize)
          endif
   RETURN lOk

   INLINE METHOD delItem(nOrd)
          LOCAL  aOldSize, lOk
          aOldSize := ::oDlg:clientSize
          lOk         := ::oMenuBar:delItem(nOrd)
                  //
                  //    Ajusta a altura de Self com a do menu de barras
          if lOk
             ::checkBrowseSize(aOldSize)
          endif
   RETURN lOk

ENDCLASS

METHOD CabBrowse_:init(oParent, oOwner, aPos, aSize)
       LOCAL  oMain
       if oParent == NIL
          oParent := AppDesktop()
       endif
                  //
                  //    Caso se deseje impor algum parmetro daqueles
                  //         de cabBROW_PP_DIALOG usar CabBrowse_:set...
       ::aPPCol   := AClone(::aPPColumns)
       if oParent == AppDesktop()
                  //
                  //    Assume tamanho e posio em relao a AppDesktop()
                  //       o tamanho de <oParent>
           if Empty(aSize)      .or.;
              aSize[01]    == 0 .or.;
              aSize[02]    == 0
              oMain        := MainAppWindow_()
              aSize        := AppDesktop():currentSize()
              aSize[02]    := (ApiGetDesktopSize_()[02] -;
                               (oMain:currentSize()[02] - oMain:clientSize[02]))
           endif
           if Empty(aPos)         .or.;
              aPos[02]       == 0
              aPos           := {0, ApiGetDesktopPosition_()[02]}
              ::lSetPosOnTop := .t.
           else
              ::lSetPosOnTop := .f.
           endif
       else
                  //
                  //    Assume tamanho e posio em relao a <oParent>
            if Empty(aSize)   .or.;
               aSize[01] == 0 .or.;
               aSize[02] == 0
               aSize     := oParent:currentSize()
               if IsMemberVar(oParent:setparent(), 'nDetailsHeight')
                  aSize[02] -= oParent:setParent():ndetailsHeight
               else
                  aSize := oParent:currentSize()
               endif
            endif
            if Empty(aPos)
               ::lSetPosOnTop :=.t.
               if IsMemberVar(oParent, 'ClientSize')
                  aPos := oParent:drawingArea:currentPos()
               else
                  apos := {0, 0}
               endif
            endif
       endif

       ::oDlg := CabDlgBrowse_():new(oParent, oOwner, aPos, aSize, ::aPPDialog, .f.)
                  //
                  //    Cria sempre visvel para que a visibilidade dependa sempre
                  //         de ::oDlg.
                  //    ::oBrowse  criado sempre com o tamanho de <oParent>
       ::XbpBrowse:init(::oDlg:drawingArea, ::oDlg:DrawingArea, {0, 0}, NIL, ::aPPCol, .t.)
       ::XbpBrowse:useVisualStyle := .f.
       ::XbpBrowse:sizeCols       := .t.
                  //
                  //    Para exibir o "Meu Assistente" quando se tecla RbDown no cabealho,
                  //         na rea de dados e no rodap
       ::XbpBrowse:headerRbDown := {|aMousePos| ::popup(aMousePos)}
       ::XbpBrowse:footerRbDown := {|aMousePos| ::popup(aMousePos)}
       ::XbpBrowse:itemRbDown   := {|aMousePos| ::popup(aMousePos)}
       ::oBrowse                := Self            // ::XbpBrowse
       ::oDlg:oBrowse           := Self

                  //
                  //    Variveis
       ::nMinWidth       := cabBROW_DLG_MINWIDTH
       ::controller      := NIL
       ::oPopup          := CabMenu_():new(::XbpBrowse, .f.)
       ::lAutoSizeWidth  := .t.
       ::lAutoSizeHeight := .t.
RETURN self

METHOD CabBrowse_:initIVars(lTitleBar, nIcon,          cTitle,          lTaskList, lMinButton, lMaxButton,;
                                       nBorder,        bClose,          bEscExit,;
                                       aMenubarItens,  aPushButtons,;
                                       aSkipInSource,;
                                       nCursorMode,    lHScroll,        lVScroll,;
                                       bHitTop,        bHitBottom,;
                                       lAutoSizeWidth, lAutoSizeHeight, lReSizeCols,;
                                       aLeftFrozen,    aRightFrozen,;
                                       bRowDetail,     lShowMovement,;
                                       bSelectedRow,;
                                       aPPCols)
       if aPPCols   <> NIL
          ::aPPCol  := AClone(aPPCols)
       endif
       if lTaskList <> NIL .and.;
          !lTaskList
          ::oDlg:taskList := .f.
       endif
       if     lTitleBar <> NIL .and.;
              !lTitleBar
              ::oDlg:titleBar := .f.
       elseif ::oDlg:taskList
              if nIcon        <> NIL; ::oDlg:icon      := nIcon;        endif
              if !Empty(cTitle)
                 ::oDlg:title    := cTitle
              endif
              if lMinButton   <> NIL; ::oDlg:minbutton := lMinButton;   endif
              if lMaxButton   <> NIL; ::oDlg:maxbutton := lMaxButton;   endif
       endif
       if nBorder       <> NIL
          ::oDlg:border := nBorder
       endif

       if bClose     == NIL
          bClose     := {|| .t.}
       endif
       ::oDlg:bClose := {|| ::exeCallBack(bClose)}

       if bEscExit   == NIL
          ::bEscExit := cabBROW_EXITESC
       else
          ::bEscExit := {|| ::exeCallBack(bEscExit)}
       endif

       if aMenubarItens   == NIL
          ::aMenubarItens := {}
       else
          ::aMenubarItens := aMenubarItens
       endif

       if aPushButtons   <> NIL
          ::aPushButtons := aPushButtons
       endif
                  //
                  //    Movimentao do Browse
                  //    Vide descrio em CabDefsX.ch em cabBROW_IND_...
                  //
                  //    Blocos de navegao
       ::XbpBrowse:skipBlock     := aSkipInSource[cabBROW_IND_SKIPBLOCK]
       ::XbpBrowse:goTopBlock    := aSkipInSource[cabBROW_IND_GOTOPBLOCK]
       ::XbpBrowse:goBottomBlock := aSkipInSource[cabBROW_IND_GOBOTTOMBLOCK]
       ::XbpBrowse:phyPosBlock   := aSkipInSource[cabBROW_IND_PHYPOSBLOCK]
       ::XbpBrowse:goPhyPosBlock := aSkipInSource[cabBROW_IND_GOPHYPOSBLOCK]
                 //
                 //     Movimento da Scroll barr
       ::XbpBrowse:posBlock      := aSkipInSource[cabBROW_IND_POSBLOCK]
       ::XbpBrowse:goPosBlock    := aSkipInSource[cabBROW_IND_GOPOSBLOCK]
       ::XbpBrowse:firstPosBlock := aSkipInSource[cabBROW_IND_FIRSTPOSBLOCK]
       ::XbpBrowse:lastPosBlock  := aSkipInSource[cabBROW_IND_LASTPOSBLOCK]

       if nCursorMode             <> NIL; ::XbpBrowse:cursorMode := nCursorMode;                endif
       if lHScroll                <> NIL; ::XbpBrowse:hScroll    := lHScroll;                   endif
       if lVScroll                <> NIL; ::XbpBrowse:vScroll    := lVScroll;                   endif
       if ::XbpBrowse:vScroll
          ::XbpBrowse:vScrollObject:usevisualStyle := .f.
          ::nRowWidth := (ApiGetScrollBarYWidth_() + 1)
       else
          ::nRowWidth := 0
       endif

       if ::XbpBrowse:hScroll
          ::XbpBrowse:hScrollObject:usevisualStyle := .f.
       endif

       if bHitTop                  == NIL
          ::XbpBrowse:hitTopBlock    := cabBROW_OVERFLOW
       else
          ::XbpBrowse:hitTopBlock    := {|| ::exeCallBack(bHitTop)}
       endif
       if bHitBottom               == NIL
          ::XbpBrowse:hitBottomBlock := cabBROW_OVERFLOW
       else
          ::XbpBrowse:hitBottomBlock := {|| ::exeCallBack(bHitBottom)}
       endif

       if lAutoSizeWidth   <> NIL; ::lAutoSizeWidth        := lAutoSizeWidth;   endif
       if lAutoSizeHeight  <> NIL; ::lAutoSizeHeight       := lAutoSizeHeight;  endif
       if lReSizeCols      <> NIL; ::XbpBrowse:sizeCols      := lReSizeCols;    endif
       if aLeftFrozen      <> NIL; ::XbpBrowse:setLeftFrozen(aLeftFrozen);      endif
       if aRightFrozen     <> NIL; ::XbpBrowse:setRightFrozen(aRightFrozen);    endif

       if bRowDetail              == NIL
          ::XbpBrowse:stableBlock := {|| ::checkMySize()}
       else
          ::bRowDetail            := bRowDetail
          ::XbpBrowse:stableBlock := {|| (::checkMySize(),;
                                          ::oDlg:showDetail(::exeCallBack(::bRowDetail)))}
       endif

       if lShowMovement           <> NIL
          ::XbpBrowse:softTrack   := lShowMovement
       endif

       if bSelectedRow             == NIL
          ::XbpBrowse:itemMarked   := cabBROW_SELECTEDROW
          ::XbpBrowse:itemSelected := cabBROW_MARKEDROW
       else
          ::XbpBrowse:itemMarked   := {|| ::exeCallBack(bSelectedRow)}
          ::XbpBrowse:itemSelected := {|| ::exeCallBack(bSelectedRow)}
       endif

RETURN Self

METHOD CabBrowse_:create()
       LOCAL  aSize, lSaveAutoHeight
       ::oDlg:create()
                  //
                  //    Create ::oMenuBar with or without items
       cabMENUBAR  NEW            ::oMenuBar;
                   CREATE         ::aMenubarItens;
                   PARENT         ::oDlg
                  //
                  //    Barra de pushbuttons
       if ::aPushButtons <> NIL
          ::oDlg:createPushBarr(::aPushButtons)
          if ::oDlg:oPushBarr:nPushesWidth  > ::nMinWidth
             ::nMinWidth                   := ::oDlg:oPushBarr:nPushesWidth
          endif
       endif
                  //
                  //    Fica abaixo do menu ou da barra de pushbuttons
       if ::bRowDetail      == NIL
          ::oDlg:oBoxDetail := NIL
       else
          ::oDlg:showDetailCreate(::exeCallBack(::bRowDetail))
       endif
       SetAppWindow(::oDlg)
                  //
                  //    Para no eliminar linhas em branco ao se criar o browse
       lSaveAutoHeight   := ::lAutoSizeHeight
       ::lAutoSizeHeight := .f.
       aSize             := ::oDlg:clientSize
       aSize[02]         -= ::oDlg:nDetailsHeight
       ::XbpBrowse:create(NIL, NIL, NIL, aSize)
                  //
                  //    "Meu Assistente"
       cabMENU    CREATE          ::oPopup;
                  ITENS           ::aOptions;
                  BARTEXT         'Meu Assistente';
                  POPUP
                  //
                  //    Processa
       ::XbpBrowse:goTop()
       ::XbpBrowse:forceStable()
       SetAppFocus(::XbpBrowse)
       ::lAutoSizeHeight := lSaveAutoHeight
RETURN Self

METHOD CabBrowse_:formatColumn(xLink, cPicture, nWidth, xHead, xFoot,;
                                      nType,    cName)
       LOCAL oColumn, xValue, nInd, nLen

       if ValType(xLink) == 'A'
          xLink          := {|| Eval(xLink)}
       endif
       if cPicture == NIL
          cPicture := ''
       endif
                  //
                  //    Formata a coluna.
                  //           A coluna  criada em MultilineCol_:create()
                  //
                  //    A primeira coluna define a quantidade de linhas
                  //      do header, rea de dados e do rodap
       if ::nHeaderLines        == NIL
          if     ValType(xHead) == 'C'
                 ::nHeaderLines := 1
          elseif ValType(xHead) == 'A'
                 ::nHeaderLines := Len(xHead)
          else
                 ::nHeaderLines := 0
          endif

          if     ValType(xFoot) == 'C'
                 ::nFootLines   := 1
          elseif ValType(xFoot) == 'A'
                 ::nFootLines   := Len(xFoot)
          else
                 ::nFootLines   := 0
          endif
       endif
                  //
                  //   Maior extenso da coluna
       if Empty(nWidth)
          if ValType(xHead) == 'A'
             nWidth         := 0
             AEval(xHead, {|x| nWidth := Max(nWidth, Len(Var2Char(x)))})
             nLen        := Len(xHead)
             if     nLen  < ::nHeaderLines
                    ASize(xHead, ::nHeaderLines)
                    for nInd := 1 to nLen
                        AIns(xHead, nInd, Space(01))
                    next
             elseif nLen  > ::nHeaderLines
                    ASize(xHead, ::nLenSize)
             endif
          else
             if ValType(xHead) == 'C'
                 nWidth        := Len(xHead)
             else
                 nWidth        := 0
             endif
          endif
          ::aPPCol[COL_HA_CAPTION, 2] := xHead

          if ValType(xFoot) == 'A'
             AEval(xFoot, {|x| nWidth := Max(nWidth, Len(Var2Char(x)))})
             nLen        := Len(xFoot)
             if     nLen  < ::nFootLines
                    ASize(xFoot, ::nFootLines)
                    for nInd := 1 to nLen
                        AIns(xFoot, nInd, Space(01))
                    next
             elseif nLen  > ::nFootLines
                    ASize(xFoot, ::nLenSize)
             endif
          else
             if ValType(xFoot) == 'C'
                nWidth         := Max(nWidth, Len(xFoot))
             endif
          endif
          ::aPPCol[COL_FA_CAPTION, 2] := xFoot

          xValue := Eval(xLink)
          if ValType(xValue) == 'A'
             AEval(xValue, {|x| nWidth := Max(nWidth, Len(Transform(x, cPicture)))})
          else
             nWidth := Max(nWidth, Len(Var2Char(Transform(xValue, cPicture))))
          endif
       endif
       ::aPPCol[COL_DA_CHARWIDTH, 2] := nWidth

       oColumn          := MultiLineCol_():new(Self, NIL, NIL, NIL, ::aPPCol)
       oColumn:datalink := xLink
       oColumn:picture  := cPicture
       if nType         <> NIL
          oColumn:type  := nType
       endif
       if cName         <> NIL
          oColumn:cName := Lower(cName)
       endif
       if ValType(xHead)  == 'A'
          oColumn:heading := MultilineCell_():new( oColumn )
       endif
       if ValType(xFoot)  == 'A'
          oColumn:footing := MultilineCell_():new( oColumn )
       endif
       oColumn:oBrowse    := Self
RETURN oColumn
                  //
                  //    Mtodo ativado pelo Xbase++ devido a Ivar
                  //           CabColumn_::drawMode ser := XBP_DRAW_OWNER
METHOD CabBrowse_:customDrawCell(oPS, aInfo)
      LOCAL  oArea, oCol, xData, nY, aRect

//?
//  Ateno: veja o alinhamento do header, dataArea e footing no programa ..\Xbase\Miscelaneous\Multi.zip
//           existe na pasta ..\Edit o programa Multi.prg que contm a funo Navigated() que no tem l


      if aInfo[ XBP_DRAWINFO_ITEM ] > 0
         oArea := aInfo[ XBP_DRAWINFO_AREA ]
         oCol  := aInfo[ XBP_DRAWINFO_COLUMN ]
         xData := oArea:getCell( aInfo[ XBP_DRAWINFO_ITEM ] )
         nY    := aInfo[ XBP_DRAWINFO_RECT, 4 ] - ::nInterline

         IF     oArea           == oCol:dataArea
                if aInfo[ XBP_DRAWINFO_STATE ] == XBP_DRAWSTATE_SELECTED
                   oPS:setColor(COL_DA_FGCLR_HILITE, COL_DA_BGCLR_HILITE)
                else
                   oPS:setColor(COL_DA_FGCLR,        COL_DA_BGCLR)
                endif
         elseif oArea == oCol:heading
                oPS:setColor(COL_HA_FA_FGCLR, COL_HA_FA_BGCLR)
         elseif oArea == oCol:footing
                oPS:setColor(COL_HA_FA_FGCLR, ::nHAFAClrBG)
         endif

         aRect := aInfo[ XBP_DRAWINFO_RECT]
         if     Valtype( xData ) == 'A'
                AEval( xData, {|xDat| GraCaptionStr( oPS, { aRect[01], nY }, { aRect[03], nY + ::nInterline }, ;
                                                     Var2Char( xDat ) ), nY -= ::nInterline } )
         elseif xData <> NIL
                GraCaptionStr( oPS, { aRect[01], nY }, { aRect[03], nY + ::nInterline }, ;
                               Transform(xData, oCol:picture))
         endif
         RETURN .f.
   endif
RETURN .T.

 ////////////
 //
STATIC CLASS MultiLineCol_ FROM XbpColumn
 //    Permite processar uma coluna com mais de uma linha em seu cabealho, rea de
 //            dados e/ou rodap.
 //    Retorna objeto da classe XbpColumn()
 /////
EXPORTED:
  VAR    cName                   // Para uso do aplicativo
  VAR    oBrowse

  INLINE METHOD init(oParent, oOwner, aPos, aSize, aPP, lVisible)
         ::XbpColumn:Init( oParent, oOwner, aPos, aSize, aPP, lVisible )
         ::dataLink := {|| { '', '' } }
         ::drawMode := XBP_DRAW_OWNER
         ::cName    := ''
  RETURN Self

  INLINE METHOD create(oParent, oOwner, aPos, aSize, aPP, lVisible)
         LOCAL  bDataLink, xValue, nAreaLines, aCellRect
                  //
                  //    Define a altura das linhas de dados a partir da primeira coluna
       bDataLink := ::XbpColumn:dataLink
       xValue    := Eval(::XbpColumn:dataLink)
       if ValType(xValue)      == 'A'
          ::XbpColumn:dataLink := {|| xValue[01]}
       endif

       if ::oBrowse:nInterline == NIL
          if ValType(xValue)   == 'A'
             nAreaLines        := Len(xValue)
          else
             nAreaLines        := 1
          endif

          ::XbpColumn:create(oParent, oOwner, aPos, aSize, aPP, lVisible)
          aCellRect     := ::XbpColumn:dataArea:cellRect(1, .t.)
          if aCellRect  == NIL
              aCellRect := ::XbpColumn:dataArea:cellRect(0, .t.)
          endif
          ::oBrowse:nInterline := Round(((aCellRect[04] - aCellRect[02]) * 1.1), 0)
          ::oBrowse:aPPCol[COL_DA_ROWHEIGHT, 02] := (::oBrowse:nInterline * nAreaLines)
          ::XbpColumn:destroy()
       endif
       ::XbpColumn:create(oParent, oOwner, aPos, aSize, aPP, lVisible)
       ::XbpColumn:dataLink := bDataLink
                  //
                  //    Obtm a extenso da linha. A ScrollBar j est includa
       ::oBrowse:nRowWidth += ::XbpColumn:currentSize()[01]
   RETURN Self

   INLINE METHOD destroy()
          ::oBrowse := NIL
   RETURN ::XbpColumn:destroy()

ENDCLASS

 ////////////
 //
STATIC CLASS MultilineCell_ FROM XbpCellGroup
 //    Usada por MultilLineCol_() para exibir a(s) linha(s) do cabealho,
 //          rea de dados ou rodap, podendo cada uma ter mais de uma linha.
 //    Retorna um objeto da classe XbpCellGroup()
 /////
EXPORTED:
  INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPP, lVisible )
         LOCAL xHeadFoot, cStrRef, nLines, nMaxLen, nLen

         xHeadFoot := ::XbpCellGroup:referenceString
         if ValType(xHeadFoot) == 'C'
            nLines             := 1
            cStrRef            := xHeadFoot
         else
            nLines  := Len(xHeadFoot)
            nMaxLen := 0
            AEval(xHeadFoot, {|x,y| (nLen     := Len(Var2Char(x)),;
                                     iif(nLen >= nMaxLen, (nMaxLen := nLen, cStrRef := Var2Char(x)), NIL))})
         endif
         ::XbpCellGroup:referenceString := cStrRef
         ::XbpCellgroup:create(oParent, oOwner, aPos, aSize, aPP, lVisible)
         aSize     := ::XbpCellgroup:currentSize()
         aSize[02] := Int((aSize[02] * (nLines * 0.95)))
         ::XbpCellgroup:setSize(aSize)
  RETURN Self
ENDCLASS
